#include "petscsys.h"
#include "petscfix.h"
#include "petsc/private/ftnimpl.h"
#include <petscsnes.h>
#include <petscsnes.h>
#if defined(PETSC_HAVE_FORTRAN_CAPS)
  #define matcreatesnesmfmore_ MATCREATESNESMFMORE
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE)
  #define matcreatesnesmfmore_ matcreatesnesmfmore
#endif
PETSC_EXTERN void matcreatesnesmfmore_(SNES *a, Vec *b, Mat *c, PetscErrorCode *ierr)
{
  PetscBool null_c = !*(void**) c ? PETSC_TRUE : PETSC_FALSE;
  CHKFORTRANNULLOBJECT(c);
  *ierr = MatCreateSNESMFMore(*a, *b, c);
  if (*ierr) return;
  if (! null_c && !*(void**) c) *(void **) c = (void *)-2;
}
#include "petscsys.h"
#include "petscfix.h"
#include "petsc/private/ftnimpl.h"
#include <petscsnes.h>
#include <petscsnes.h>
#if defined(PETSC_HAVE_FORTRAN_CAPS)
  #define matsnesmfmoresetparameters_ MATSNESMFMORESETPARAMETERS
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE)
  #define matsnesmfmoresetparameters_ matsnesmfmoresetparameters
#endif
PETSC_EXTERN void matsnesmfmoresetparameters_(Mat *a, PetscReal *b, PetscReal *c, PetscReal *d, PetscErrorCode *ierr)
{
  *ierr = MatSNESMFMoreSetParameters(*a, *b, *c, *d);
  if (*ierr) return;
}
